<template>
    <div class="newsname">
        <select class="filter" v-model="selectedFilter" @change="changeFilter" >
            <option value="" disabled selected hidden>Select filter type</option>
            <option v-for="filterItem of filters" :key="filterItem" aria-placeholder="---Pick a Filter---" >
                {{filterItem}}
            </option>
        </select>

        <select class="value" v-model="Selectedresource" @change="resourceChanged">
            <option value="" disabled selected hidden>Select value</option>
            <option
                v-for="(item, index) in items"
                :key="'filter-option-' + index"
                :value="item"
                >{{item.name}}</option>
        </select>
    </div>
</template>

<script>
    export default {
        name: 'newsname',
        data () {
            return{
                filters: ['Sources','Country','Category'],
                selectedFilter: '',
                items: [],
                Selectedresource: '',
                countries: [
                    {"name": "Argentina", "code": "AR"},
                    {"name": "Australia", "code": "AU"},
                    {"name": "Austria", "code": "AT"},
                    {"name": "Brazil", "code": "BR"},
                    {"name": "Bulgaria", "code": "BG"},
                    {"name": "Canada", "code": "CA"},
                    {"name": "China", "code": "CN"},
                    {"name": "Colombia", "code": "CO"},
                    {"name": "Czech Republic", "code": "CZ"},
                    {"name": "France", "code": "FR"},
                    {"name": "India", "code": "IN"},
                    {"name": "Korea, Republic of", "code": "KR"},
                    {"name": "Mexico", "code": "MX"},
                    {"name": "Netherlands", "code": "NL"},
                    {"name": "Netherlands Antilles", "code": "AN"},
                    {"name": "Norway", "code": "NO"},
                    {"name": "Russian Federation", "code": "RU"},
                    {"name": "San Marino", "code": "SM"},
                    {"name": "Sao Tome and Principe", "code": "ST"},
                    {"name": "Saudi Arabia", "code": "SA"},
                    {"name": "South Africa", "code": "ZA"},
                    {"name": "Sweden", "code": "SE"},
                    {"name": "Switzerland", "code": "CH"},
                    {"name": "Ukraine", "code": "UA"},
                    {"name": "United Arab Emirates", "code": "AE"},
                    {"name": "United Kingdom", "code": "GB"},
                    {"name": "United States", "code": "US"},
                ],
                categories:[
                    {"name": "business"},
                        {"name": "entertainment"},
                        {"name": "general"},
                        {"name": "health"},
                        {"name": "science"},
                        {"name": "sports"},
                        {"name": "technology"}
                ],
                filter: {
                    "id":'',
                    "value":'',
                },
            };
            
                
            
        },
          props:{
                    pageNumber: {
                        type: Number
                    }
                },
        methods: {
            changeFilter: function(){
                if(this.selectedFilter == 'Sources'){
                        this.$http.get('https://newsapi.org/v2/sources?apiKey=7c54c8f938a04a2a835789dabc9b8d28')
                .then( res => {
                  this.items = res.body.sources; 
                })
                }
                else if(this.selectedFilter == 'Country'){
                    this.items = this.countries
                }
                else if(this.selectedFilter == 'Category'){
                    this.items = this.categories
                }
              
            }, 
            
            resourceChanged: function () {
                let id = this.selectedFilter;

                this.filter.id = id;
                
                switch( this.selectedFilter ) {
                    case 'Country':
                        this.filter.value = this.Selectedresource.code;
                        break;
                    case 'Category':
                        this.filter.value = this.Selectedresource.name;
                        break;
                    case 'Sources':
                        this.filter.value = this.Selectedresource.id;
                        break;
                }
            
                this.$emit('resourceChanged',this.filter,this.pageNumber);
                
            },
        },    
        watch: {
            pageNumber : function(val) {
                this.pageNumber = val; 
                this.resourceChanged();
            }
        } 
    }
</script>

<style scoped>
.newsname{
    width: 100%;
    padding: 16px;
    display: flex;
    justify-content: flex-end;
    align-items: center;
    border-radius: 4px;
    box-shadow: 1px 1px 5px 1px rgba(0,0,0,.3);
    background: rgb(255, 255, 255,0.7);

    
}
h5 {
    margin-right: 16px;
}
.filter {
    max-width: 200px;
    width: 40%;
    margin-right: 16px;
}

.value {
    max-width: 200px;
    width: 30%;
}

select{
}

</style>